
EnableExplicit

XIncludeFile "CT_xyChart.pbi"

Enumeration
   #WIN
   #CVA
EndEnumeration
#CVAx = 10
#CVAy = 10
#CVAw = 1000

Procedure MainWindow_Create()
   If OpenWindow(#WIN, 0, 0, #CVAw, #CVAw/1.6, "CanvasGadget", #PB_Window_MaximizeGadget|#PB_Window_ScreenCentered|#PB_Window_SizeGadget)
      CanvasGadget(#CVA, #CVAx, #CVAY, WindowWidth(#WIN)-20, WindowHeight(#WIN)-20, #PB_Canvas_Border)
   EndIf
EndProcedure

Procedure.i MainChart_Create()
   Protected pID.i
   
   pID = ctxyChart_New(#CVA)
   ctxyChart_xRasterPitch(20)
   ctxyChart_Nachkomma  (0)
   ctxyChart_yKoordinate(2000, 4100)
   ctxyChart_xKoordinate(5000, 8000)
   ctxyChart_Invers()
   ctxyChart_Titel ("Test")
   ctxyChart_xTitel("[Anzahl]")
   ctxyChart_yTitel("[Byte]")
   ctxyChart_ChartColor(#Blue)
   ProcedureReturn pID
EndProcedure

Procedure Data_Load(List vData.ctxyChart_Point())
   Protected pDS.s
   
   If ReadFile(0, "xyChart.txt")
      While Not Eof(0)
         pDs = ReadString(0)
         If pDS
            AddElement(vData())
            With vData()
               \x = Val(StringField(pDs, 1, ";"))
               \y = Val(StringField(pDs, 2, ";"))
            EndWith
         EndIf
      Wend
      CloseFile(0)
   EndIf
EndProcedure

Procedure Main()
   Protected n.i, pChartID.i, pEvent.i, pQuit.a,pX.s, pY.s
   Protected NewList pChart.ctxyChart_Point()
   
   MainWindow_Create()
   pChartID = MainChart_Create()
   Data_Load(pChart())
   
   Repeat
      pEvent = WaitWindowEvent()
      Select pEvent
         Case #PB_Event_CloseWindow: pQuit = #True
         Case #PB_Event_SizeWindow
            ResizeGadget(#CVA, #PB_Ignore, #PB_Ignore, WindowWidth(#WIN)-20, WindowHeight(#WIN)-20)
            ctxyChart_FontSize(GadgetWidth(#CVA)/100)
            ctxyChart_Present()
            ctxyChart_DrawList(pChart(), #Red, 1);#ctxyChart_Point)
         Case #PB_Event_Gadget   
            If (EventGadget()=#CVA) And (EventType()=#PB_EventType_RightButtonDown)
               pX = StrF(ValF(ctxyChart_xPosition(GetGadgetAttribute(#CVA, #PB_Canvas_MouseX))), 1)
               pY = StrF(ValF(ctxyChart_yPosition(GetGadgetAttribute(#CVA, #PB_Canvas_MouseY))), 1)
               If pX And PY
                  MessageRequester("InfoBox", "X/Anzahl = " + pX + #LF$ + "Y/Byte = " + pY)
               EndIf
            EndIf
      EndSelect
   Until pQuit
EndProcedure

Main()
End
  